﻿using IDU.Core.DataStructures.PropertyModel;
using IduIT.cardo.Core.Api.Applications.Security;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace $safeprojectname$.Application
{
	//TODO: Anpassungen vornehmen, *vor* dem 1. Registrieren der Anwendung
	//Der Enum-Typ *muss* die Werte Undefined = 0 und Prohibited = 1 definieren!
	//Alle folgenden Angaben können frei bestimmt werden.

	/// <summary>
	/// Berechtigungsarten für diese Anwendung
	/// </summary>
	[Flags]
	public enum RightFlags
	{
		/// <summary>
		/// Der von der cardo-Api geforderte obligatorische Wert für undefiniert (0)
		/// </summary>
		Undefined = 0,
		/// <summary>
		/// Der von der cardo-Api geforderte obligatorische Wert für verboten (1)
		/// </summary>
		Prohibited = 1,

		/// <summary>
		/// Lesezugriff auf die Daten
		/// </summary>
		Read = 2,
		/// <summary>
		/// Schreibzugriff auf die Daten
		/// </summary>
		Write = 4
	}
	/// <summary>
	/// Klasse für Berechtigungen in der Anwendung. Wesentlich ist der bereitgestellt Member EffectiveSecurity.
	/// Zudem benötigt die Laufzeitumgebung CreateSecurityNodeForImport() für den Import der Datenstruktur.
	/// In der Anwendungsklasse können dann beliebig viele Properties eingefügt werden. Der Themen-Baum-Identifier wird aus dem Namen der Eigenschaft erstellt,
	/// der Typ wird von der entsprechenden Klasse abgeleitet.
	/// </summary>
	internal sealed class ApplicationRights : ApplicationSecurityRights<RightFlags>
	{
		public override ApplicationSecurityRightsImportNodes CreateSecurityNodeForImportOrUpdates(IduIT.cardo.Core.Api.Applications.ICardoManagedApplication registeredInstanceIfReload)
		{
			//registeredInstanceIfReload ist == null, wenn die Anwendung
			//gerade neu registriert wird.
			//Sonst ist die Anwendung bereits registriert, der Rechte-Baum 
			//kann dann z.B. aus der Datenstruktur generiert werden.

			return new ApplicationSecurityRightsImportNodes("Default", "Berechtigungen")
					//Knoten anfügen ... z.B. via 
					//.AddChildReturnThis
					//.CreateChild ...
					;
		}
	}
}
