﻿namespace $safeprojectname$.Application.Components
{
	/**
	 * Hauptkomponente der Anwendung
	 */
	export class MainComponent extends IduIT.Core.Kiss.Ui.Core.Component
	{
		////////////////////////////////////////////////////
		// Überladungen von Kiss.Ui.Core.Component
		////////////////////////////////////////////////////
		/**
		 * Erstellt eine neue Instanz.
		 * 
		 * @param cfg Config-Objekt.
		 */
		public constructor(cfg?: IduIT.Core.Kiss.Ui.Core.Component.IComponentConfig)
		{
			super(cfg);
		}

		/**
		 * Führt vorbereitende Aktionen aus, bevor die Konfiguration gesetzt wird.
		 */
		protected _prepareComponent(): void
		{
			super._prepareComponent();
			//z.B.: this._componentCls = 'iduit-app-dvb-dvbcadfilehandler-component';
		}

		/**
		 * Setzt die Konfiguration der Komponente.
		 * 
		 * @param cfg Config-Objekt.
		 */
		protected _initConfig(cfg: IduIT.Core.Kiss.Ui.Core.Component.IComponentConfig): void
		{
			super._initConfig(cfg);
		}

		/**
		 * Führt die Initialisierung der Komponente aus, nachdem die Konfiguration gesetzt wurde.
		 * 
		 * @param cfg Die Konfiguration, die der Komponente übergeben wurde.
		 */
		protected _initComponent(cfg: IduIT.Core.Kiss.Ui.Core.Component.IComponentConfig): void
		{
			super._initComponent(cfg);

			this._setLayout(new IduIT.Core.Kiss.Ui.Layout.VBox);

			this._add(new IduIT.Core.Kiss.Ui.Core.Text({
				flex: 1,
				content: "Hallo, <b>cardo4!</b>",
				mode: IduIT.Core.Kiss.Ui.Core.ETextMode.Html
			}));

			this._add(new IduIT.Core.Kiss.Ui.Toolbar.Footer({
				items: [
					new IduIT.Core.Kiss.Ui.Core.Text({
						content: 'Status',
						mode: IduIT.Core.Kiss.Ui.Core.ETextMode.Html
					}),
					new IduIT.Core.Kiss.Ui.Toolbar.Separator({
						flex: 1,
						visibility: IduIT.Core.Kiss.Ui.Core.EVisibility.Blank
					})
				]
			}));
		}

		/**
		 * Initialisiert die Events der Komponente.
		 */
		protected _initEvents(): void
		{
			super._initEvents();
		}

		/**
		 * Dispose.
		 */
		public dispose(): void
		{
			super.dispose();
			Kiss.Util.Disposer.disposeMembers(this /* sowie weitere Member, die nicht als Control hinzugefügt wurden */);
		}

		////////////////////////////////////////////////////
		// Eigene Methoden und Eigenschaften
		////////////////////////////////////////////////////

		/**
		 * Bsp. Eigenschaft
		 */
		public get hasUnsavedChanges(): boolean
		{
			return false;
		}

	}
}
